/*  $Id: event_listener_unix.cpp,v 1.10 2004/02/05 14:11:06 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Core/precomp.h"
#include "event_listener_unix.h"
#include "event_trigger_unix.h"
#include "API/Core/System/system.h"

// note: this cannot be replaced by <ctime>! (timeval needs to be defined)
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

/////////////////////////////////////////////////////////////////////////////
// CL_EventListener_Unix construction:

CL_EventListener_Unix::CL_EventListener_Unix(CL_EventListener *owner)
:
	CL_EventListener_Generic(owner)
{
}

CL_EventListener_Unix::~CL_EventListener_Unix()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_EventListener_Unix implementation:

bool CL_EventListener_Unix::wait(int timeout)
{
	if (triggers.empty()) // no triggers, just do the sleep.
	{
		CL_System::sleep(timeout);
		return false;
	}

	fd_set rfds;
	FD_ZERO(&rfds);
	int highest_fd = -1;

	std::list< CL_SharedPtr<CL_EventTrigger_Generic> >::iterator it;
	for (it = triggers.begin(); it != triggers.end(); ++it)
	{
		CL_EventTrigger_Unix *trigger = static_cast<CL_EventTrigger_Unix*>((*it).get());
		
		if (trigger->wait_pipe[0] > highest_fd) highest_fd = trigger->wait_pipe[0];
		FD_SET(trigger->wait_pipe[0], &rfds);
	}
	
	timeval tv;
	tv.tv_sec = timeout/1000;
	tv.tv_usec = (timeout%1000)*1000;

	int result = select(
		highest_fd+1,
		&rfds,
		NULL,
		NULL,
		(timeout == -1) ? NULL : &tv);

	if (result <= 0) return false;
	return true;
}
